#include "fileOperations.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int loadGame( const char *fileName, Game *game ) {
    FILE *f = fopen( fileName, "r" );
    if ( !f )
        return 0;
    
    fscanf( f, "%d%d", &game->width, &game->height );

    game->map = (char*)malloc( game->width * game->height );
    fgetc( f );// erase '\n'
    for ( int y = 0; y < game->height; ++y ) {
        for ( int x = 0; x < game->width; ++x ) {
            *mapAt( game, x, y ) = fgetc( f );
        }
        fgetc( f );// erase '\n'
    }
    char weaponType;
    fscanf( f, "%d%d%d %c%d",
            &game->player.position.x,
            &game->player.position.y,
            &game->player.health,
            &weaponType,
            &game->player.weapon.attack
            );
    game->player.weapon.type = getWeapon( weaponType );
    if ( game->player.weapon.type == UnkownWeapon || game->player.weapon.type == NoWeapon )
        game->player.weapon.attack = 0;

    game->notification = NULL;
    if ( game->gameName ) {
        free( (void*)game->gameName );
    }
    char *name = (char*)malloc( strlen( fileName ) + 1 );
    strcpy( name, fileName );
    game->gameName = name;

    fclose( f );
    return 1;
}

int saveGame( const char *fileName, Game *game ) {
    FILE *f = fopen( fileName, "w" );
    if ( !f )
        return 0;

    fprintf( f, "%d %d\n", game->width, game->height );
    for ( int y = 0; y < game->height; ++y ) {
        for ( int x = 0; x < game->width; ++x )
            fputc( readMapAt( game, x, y ), f );
        fputc( '\n', f );
    }
    fprintf( f, "%d %d %d %c %d\n", 
             game->player.position.x,
             game->player.position.y,
             game->player.health,
       (char)game->player.weapon.type,
             game->player.weapon.attack );

    if ( game->gameName ) {
        free( (void*)game->gameName );
    }
    char *name = (char*)malloc( strlen( fileName ) + 1 );
    strcpy( name, fileName );
    game->gameName = name;

    fclose( f );
    return 1;
}
