#ifndef GAME_H_
#define GAME_H_

typedef struct {
    int x;
    int y;
} Position;

enum Weapons {
    NoWeapon = '-',
    Axe = 'a',
    Bow = 'b',
    Sword = 's',
    UnkownWeapon = '?'
};

typedef struct {
    enum Weapons type;
    int attack;
} Weapon;

typedef struct {
    Position position;
    int health;
    Weapon weapon;
    int killed;
} Player;

typedef struct Notification {
    const char *msg;
    struct Notification *next;
} Notification;

typedef struct Game {
    int width;
    int height;
    char *map;
    Player player;
    const char *gameName;
    Notification *notification;
    int( *customResponseHandler )( struct Game *game, char command );
} Game;

enum Weapons getWeapon( char weapon );
const char *weaponType( enum Weapons type );
char readMapAt( const Game *game, int x, int y );
char *mapAt( Game *game, int x, int y );
char readMapAtPlayer( const Game *game );
char *mapAtPlayer( Game *game );

void startGame( const char *fileName );

#endif